#ifndef KI_DYNARRAY_H__
#define KI_DYNARRAY_H__

typedef struct {
  size_t  element_size;
  size_t  len;
  void   *elements;
} Dynarray;

Dynarray* DynarrayNew(size_t element_size);
Dynarray* DynarrayNewLength(size_t element_size, size_t length);
bool      DynarrayEnsureCapacity(Dynarray *darray, size_t length);
void*     DynarrayNewElementAtEnd(Dynarray *darray);
void*     DynarrayNewElementAtBeginning(Dynarray *darray);
void*     DynarrayIndex(Dynarray *darray, size_t index);
void      DynarrayClear(Dynarray *darray);
void      DynarrayFree(Dynarray *darray);

#endif

/* vi: set et ts=2 sw=2: */

